﻿using Ant_Colony_Optimalization.Graphic.Object;
using System;
using System.Linq;

namespace Ant_Colony_Optimalization.Graph
{
    public class CNode : IEquatable<CNode>
    {
        public const double ALPHA = 3;
        public const double BETA = 2;

        public int id { get; set; }
        public CEdge[] EdgeArray { get; set; }

        public double[] ProbabilityArray { get; set; }
        public double[] CumulProbabilityArray { get; set; }
        public CNodePoint Point { get; set; }

        public int edgeCount { get; set; }

        public CNode(int id, CNodePoint point, int EdgeCount)
        {
            this.id = id;
            this.Point = point;
            this.EdgeArray = new CEdge[EdgeCount];
            this.edgeCount = 0;
        }

        public void AddEdge(CEdge edge)
        {
            this.EdgeArray[this.edgeCount] = edge;
            this.edgeCount++;
        }


        public string ToString()
        {
            return this.id.ToString();
        }

        public bool Equals(CNode other)
        {
            return this.Point.Equals(other.Point);
        }

        public void SetEdgeCount(int count)
        {
            this.EdgeArray = new CEdge[count];
        }

        public void RemoveNullNodes()
        {
            this.EdgeArray = this.EdgeArray.Where(x => x!=null).ToArray();
        }

        public void RemoveEdge(CEdge edge){
            for (int i = 0; i < this.EdgeArray.Count(); i++)
            {
                if (this.EdgeArray[i]!=null){
                    if (this.EdgeArray[i].Equals(edge))
                    {
                        this.EdgeArray[i] = null;
                    }
                }
            }
        }

        public string ToStringExport()
        {
            return "N "+this.Point.X+" "+this.Point.Y;
        }
    }
}
