﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ant_Colony_Optimalization.Graphic.Object
{
    public class CNodePoint : IEquatable<CNodePoint>
    {
        private int NODE_RADIUS = 5;

        private Point point;

        public int X
        {
            get
            {
                return this.point.X;
            }
            set
            {
                this.point.X = value;
            }
        }
        public int Y
        {
            get
            {
                return this.point.Y;
            }
            set
            {
                this.point.Y = value;
            }
        }

        public Point Point
        {
            get
            {
                return this.point;
            }
            set
            {
                this.point = value;
            }
        }

        public CNodePoint(int x, int y)
        {
            this.point = new Point(x, y);
        }

        public CNodePoint(Point point)
        {
            this.point = point;
        }

        public bool Equals(CNodePoint nodePoint)
        {
            if (nodePoint == null)
            {
                return false;
            }

            if (((this.point.X - NODE_RADIUS) <= nodePoint.point.X && (this.point.X + NODE_RADIUS) >= nodePoint.point.X) &&
            ((this.point.Y - NODE_RADIUS) <= nodePoint.point.Y && (this.point.Y + NODE_RADIUS) >= nodePoint.point.Y))
            {
                return true;
            }
            else
            {
                return false;
            }
        }


    }
}
